﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.IO.IsolatedStorage;
using Infragistics.Persistence;
using System.IO;
using Infragistics.Controls.Grids;

namespace SilverlightApplication134
{
    public partial class MainPage : UserControl
    {

        ObservableCollection<Person> people = new ObservableCollection<Person>();
        PersistenceGroup _SettingsGroup;
        PersistenceSettings settings;
        string fileName = "TEST";
      
        public MainPage()
        {
            InitializeComponent();
            _SettingsGroup = (PersistenceGroup) LayoutRoot.Resources["SETTINGS"] as PersistenceGroup;
            settings = (PersistenceSettings)LayoutRoot.Resources["ColumnSettings"] as PersistenceSettings;
            settings.Events.PersistenceSaved += new EventHandler<PersistenceSavedEventArgs>(Events_PersistenceSaved);
            settings.Events.PersistenceLoaded += new EventHandler<PersistenceLoadedEventArgs>(Events_PersistenceLoaded);

        }

        void Events_PersistenceLoaded(object sender, PersistenceLoadedEventArgs e)
        {
            //throw new NotImplementedException();
            foreach (Column c in xgrid1.Columns)
            {
                int i = int.Parse(c.Tag.ToString());
                xgrid1.Columns.Remove(c);
                xgrid1.Columns.Insert(i, c);

            }
        }

        void Events_PersistenceSaved(object sender, PersistenceSavedEventArgs e)
        {
            //throw new NotImplementedException();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            for (int i = 0; i < 15; i++)  
            {
                Person p = new Person()
                {
                    Name = "name " + i.ToString(),
                    Status = i % 2
                };

               people.Add(p);
            }

            xgrid1.ItemsSource = people;
                 
                 


        }

        //private void addnew_Click(object sender, RoutedEventArgs e)
        //{
        //    Person p = new Person();
        //    p.Name = "name " + people.Count.ToString();
        //    p.Status = people.Count % 2;
        //    people.Add(p);
        //}

        private void save_Click(object sender, RoutedEventArgs e)
        {
            foreach (Column c in xgrid1.Columns)
            {
                int i = xgrid1.Columns.IndexOf(c);
                c.Tag = i.ToString();
            }
            SaveIntoIsolatedStorage();
        }

        private void Load_Click(object sender, RoutedEventArgs e)
        {
            LoadFromIsolatedStorage();
           
        }

        private void SaveIntoIsolatedStorage()
        {

            // Obtains user-scoped isolated storage and creates a file with persistence settings
            using (IsolatedStorageFile iso = IsolatedStorageFile.GetUserStoreForApplication())
            {
                if (iso.FileExists(fileName))
                    iso.DeleteFile(fileName);

                using (IsolatedStorageFileStream stream = new IsolatedStorageFileStream(fileName, FileMode.OpenOrCreate, iso))
                {
                    using (MemoryStream ms = PersistenceManager.Save(_SettingsGroup))
                    {
                        stream.Write(ms.ToArray(), 0, (int)ms.Length);

                    }
                }
            }
        }

        private void LoadFromIsolatedStorage()
        {
            using (IsolatedStorageFile iso = IsolatedStorageFile.GetUserStoreForApplication())
            {
                if (iso.FileExists(fileName))
                {
                    using (IsolatedStorageFileStream stream = new IsolatedStorageFileStream(fileName, FileMode.OpenOrCreate, iso))
                    {
                        // loads persistence settings from IsolatedStorageFileStream into DependencyObject
                        PersistenceManager.Load(_SettingsGroup, stream);
                    }
                }
            }
        }

    }
}
